#ifdef VHDL
/*
 * $Id: Multiplier_vhdl.cpp 116 2009-04-30 13:51:41Z moulu $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Multiplier/include/Multiplier.h"
#include "Behavioural/include/Vhdl.h"

namespace morpheo                    {
namespace behavioural {
namespace generic {
namespace multiplier {


#undef  FUNCTION
#define FUNCTION "Multiplier::vhdl"
  void Multiplier::vhdl (void)
  {
    log_begin(Multiplier,FUNCTION);

    Vhdl * vhdl = new Vhdl (_name);

    _interfaces->set_port(vhdl);
    _component->vhdl_instance(vhdl);

    // default architecture
    vhdl_declaration (vhdl);
    vhdl_body        (vhdl);

    // Xilinx architecture
    vhdl->set_architecture("xilinx");
    vhdl_xilinx_declaration (vhdl);
    vhdl_xilinx_body        (vhdl);

    vhdl->generate_file();

    delete vhdl;

    log_end(Multiplier,FUNCTION);
  };

}; // end namespace multiplier
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
